#include "stdafx.h"
#include "FriendListDragHelper.h"
#include "NeMessengerDlg.h"


CFriendListDragHelper::CFriendListDragHelper():
   m_pFriendListCtrl(NULL)
{

}

bool CFriendListDragHelper::IsSingleGroup(list<Node*>& selectedItems)
{
	if(selectedItems.size() == 1)
	{
		list<Node*>::iterator it = selectedItems.begin();

		Node* pNode = *it;

		if(IsGroupNode(pNode))
			return true;
	}

	return false;
}

bool CFriendListDragHelper::IsGroupNode(Node* pNode)
{
	if(pNode != NULL && pNode->folder() && !pNode->IsRoot())
		return true;

	return false;
}

bool CFriendListDragHelper::DoGroupDragSort(Node* pTargetGroupNode, Node* pDragGroupNode)
{
	if (  !IsGroupNode(pDragGroupNode))
	{
		
		return false;
	}

	if (!IsGroupNode(pTargetGroupNode) )
	{
		pTargetGroupNode = pTargetGroupNode->parent();
		if (!IsGroupNode(pTargetGroupNode))
		{
			return false;
		}
	}

	const IGTBuddyGroup* pGroupTarget = (IGTBuddyGroup*)pTargetGroupNode->GetNodeUserData();

	const IGTBuddyGroup* pGroupMoveItem = (IGTBuddyGroup*)pDragGroupNode->GetNodeUserData();

	if (NULL == pGroupTarget || NULL == pGroupMoveItem)
	{
		ASSERT(FALSE);
		return false;
	}

	std::vector<GT_BUDDY_GROUP_DATA> vecGroupInfo;

	if (pGroupTarget->GetSortOrder() == pGroupMoveItem->GetSortOrder())
	{
		return true;
	}
	else if(pGroupTarget->GetSortOrder() > pGroupMoveItem->GetSortOrder())
	{
		//is down
		vecGroupInfo.clear();
		int nPrevMoveItemSortOrder = pGroupMoveItem->GetSortOrder();
		int nPrevTargetItemSortOrder = pGroupTarget->GetSortOrder();

		GT_BUDDY_GROUP_DATA groupdata;
		groupdata.nID = pGroupMoveItem->GetID();
		groupdata.nSortOrder = pGroupTarget->GetSortOrder();
		CString strGroupName(pGroupMoveItem->GetName());
		wcscpy_s(groupdata.strName, strGroupName.GetLength() + 1, strGroupName.GetBuffer() );
		vecGroupInfo.push_back(groupdata);
		int nNextSortOrder = 1;

		ASSERT(m_pFriendListCtrl != NULL);

		std::vector<Node*> vecAllNodes = m_pFriendListCtrl->GetAllItems();

		for(std::vector<Node*>::iterator it = vecAllNodes.begin(); it != vecAllNodes.end(); it++)
		{
			Node* pNode = *it;

			if (IsGroupNode(pNode))
			{
				const IGTBuddyGroup* pGroupResortItem = (IGTBuddyGroup*)pNode->GetNodeUserData();

				if (pGroupResortItem && (pGroupResortItem != pGroupMoveItem))
				{
					if (pGroupResortItem->GetSortOrder() > nPrevMoveItemSortOrder && pGroupResortItem->GetSortOrder() <= nPrevTargetItemSortOrder)
					{
						groupdata.nID = pGroupResortItem->GetID();
						groupdata.nSortOrder = pGroupResortItem->GetSortOrder() - 1;
						strGroupName=pGroupResortItem->GetName();
						wcscpy_s(groupdata.strName, strGroupName.GetLength() + 1, strGroupName.GetBuffer() );

					}
					else
					{
						groupdata.nID = pGroupResortItem->GetID();
						groupdata.nSortOrder = nNextSortOrder;
						strGroupName=pGroupResortItem->GetName();
						wcscpy_s(groupdata.strName, strGroupName.GetLength() + 1, strGroupName.GetBuffer() );

					}
					vecGroupInfo.push_back(groupdata);
				}
				nNextSortOrder++;
			}
		}

	}
	else if (pGroupTarget->GetSortOrder() < pGroupMoveItem->GetSortOrder())
	{
		//is UP
		vecGroupInfo.clear();
		int nPrevMoveItemSortOrder = pGroupMoveItem->GetSortOrder();
		int nPrevTargetItemSortOrder = pGroupTarget->GetSortOrder();

		GT_BUDDY_GROUP_DATA groupdata;
		groupdata.nID = pGroupMoveItem->GetID();
		groupdata.nSortOrder = pGroupTarget->GetSortOrder();
		CString strGroupName(pGroupMoveItem->GetName());
		wcscpy_s(groupdata.strName, strGroupName.GetLength() + 1, strGroupName.GetBuffer() );
		vecGroupInfo.push_back(groupdata);
		int nNextSortOrder = 1;

		ASSERT(m_pFriendListCtrl != NULL);

		std::vector<Node*> vecAllNodes = m_pFriendListCtrl->GetAllItems();

		for(std::vector<Node*>::iterator it = vecAllNodes.begin(); it != vecAllNodes.end(); it++)
		{
			Node* pNode = *it;

			if (IsGroupNode(pNode))
			{
				const IGTBuddyGroup* pGroupResortItem = (IGTBuddyGroup*)pNode->GetNodeUserData();

				if (pGroupResortItem && (pGroupResortItem != pGroupMoveItem))
				{
					if (pGroupResortItem->GetSortOrder() >= nPrevTargetItemSortOrder )
					{
						groupdata.nID = pGroupResortItem->GetID();
						groupdata.nSortOrder = pGroupResortItem->GetSortOrder() + 1;
						strGroupName=pGroupResortItem->GetName();
						wcscpy_s(groupdata.strName, strGroupName.GetLength() + 1, strGroupName.GetBuffer() );

					}
					else
					{
						groupdata.nID = pGroupResortItem->GetID();
						groupdata.nSortOrder = nNextSortOrder;
						strGroupName=pGroupResortItem->GetName();
						wcscpy_s(groupdata.strName, strGroupName.GetLength() + 1, strGroupName.GetBuffer() );

					}
					vecGroupInfo.push_back(groupdata);
				}
				nNextSortOrder++;
			}
		}
	}

	bool bRet =	GET_MESSENGER_DLG()->ProcGroupSort(vecGroupInfo);
	return bRet;
}
